// AsaMenuEngine.cpp : t@C
// |bvAbvj[̕\::AsagiriGetXXX()̒l擾֐̌Ăяos܂B
// Copyright (C) 2003-2004 Comona Co., Ltd.
//

#include "stdafx.h"
#include "SampApp.h"
#include "AsaMenuEngine.h"
#include "AsaItem.h"

#ifdef _EXPLICIT_LOAD_
#include "AsagiriWrapper.h"
#endif

// CAsaMenuEngine

// RXgN^
CAsaMenuEngine::CAsaMenuEngine()
{
	m_pCmdTargetWnd = NULL;
#ifndef _EXPLICIT_LOAD_
	m_hAsagiri = NULL;
#else
	m_pAsagiri = NULL;
#endif
	m_pRootItem = NULL;
}

// fXgN^
CAsaMenuEngine::~CAsaMenuEngine()
{
	delete m_pRootItem;
}

// CAsaMenuEngine o֐

// IDf[^o܂
BOOL CAsaMenuEngine::GetAsagiriItemData(UINT nID, short* pnType,
										LPTSTR* lplpszTitle, HBITMAP* phBmp, LPBYTE* lplpBinary, LPDWORD lpdwSize,
										LPTSTR* lplpszServerPath)
{
	WORD wID = (WORD) nID;
	CAsaItem* pItem = NULL;
	BOOL fRet = m_mapItem.Lookup(wID, (CObject*&) pItem);
	if (fRet != FALSE) {
		*pnType = pItem->GetType();
		switch (pItem->GetType()) {
			case ASATYPE_STRING:
			case ASATYPE_STRINGFILE:
#ifndef _EXPLICIT_LOAD_
				fRet = ::AsagiriGetText(m_hAsagiri, pItem->GetID(), lplpszTitle, lplpszServerPath);
#else
				fRet = m_pAsagiri->GetText(pItem->GetID(), lplpszTitle, lplpszServerPath);
#endif
				break;
			case ASATYPE_BITMAP:
			case ASATYPE_BITMAPFILE:
#ifndef _EXPLICIT_LOAD_
				fRet = ::AsagiriGetBitmap(m_hAsagiri, pItem->GetID(), phBmp, lplpszServerPath);
#else
				fRet = m_pAsagiri->GetBitmap(pItem->GetID(), phBmp, lplpszServerPath);
#endif
				break;
			case ASATYPE_BINARY:
			case ASATYPE_BINARYFILE:
#ifndef _EXPLICIT_LOAD_
				fRet = ::AsagiriGetBinary(m_hAsagiri, pItem->GetID(), lplpBinary, lpdwSize, lplpszServerPath);
#else
				fRet = m_pAsagiri->GetBinary(pItem->GetID(), lplpBinary, lpdwSize, lplpszServerPath);
#endif
				break;
			default:
				fRet = FALSE;
				break;
		}
	}
	else {
		*pnType = ASATYPE_UNKNOWN;
	}
	return fRet;
}

// |bvAbvj[\܂
BOOL CAsaMenuEngine::ShowPopupMenu(short nType, CWnd* pWndPos)
{
	BOOL fRet = FALSE;
	m_mapItem.RemoveAll();
	delete m_pRootItem;
#ifndef _EXPLICIT_LOAD_
	m_pRootItem = CAsaItem::Create(m_hAsagiri, nType, &m_mapItem);
#else
	m_pRootItem = CAsaItem::Create(m_pAsagiri, nType, &m_mapItem);
#endif
	if (m_pRootItem != NULL) {
		fRet = TRUE;
	}
	CMenu* pPopup = m_pRootItem->CreateMenu();
	if (pPopup != NULL) {
		CRect rect;
		pWndPos->GetWindowRect(&rect);
		fRet = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			rect.left, rect.bottom, m_pCmdTargetWnd);
		m_pCmdTargetWnd->PostMessage(WM_NULL);
	}

	return fRet;
}
