// PopupItem.cpp : t@C
// |bvAbvACe̓s߂̃NXłB
// Copyright (C) 2003-2004 Comona Co., Ltd.
//
#include "StdAfx.h"
#include "SampApp.h"
#include "PopupItem.h"
#include "ValueItem.h"

#ifdef _EXPLICIT_LOAD_
#include "AsagiriWrapper.h"
#endif

// RXgN^
CPopupItem::CPopupItem()
{
	m_nType = ASATYPE_POPUP;
}

// fXgN^
CPopupItem::~CPopupItem()
{
	for (int i = 0; i < m_arItems.GetSize(); i++) {
		delete m_arItems.GetAt(i);
	}
}

// _E[hꂽACej[쐬܂
#ifndef _EXPLICIT_LOAD_
int CPopupItem::Populate(HANDLE hAsagiri, short nType, CMapWordToOb* pMap)
#else
int CPopupItem::Populate(CAsagiriWrapper* pAsagiri, short nType, CMapWordToOb* pMap)
#endif
{
	int nRet = -1;

#ifndef _EXPLICIT_LOAD_
	HANDLE hEnum = ::AsagiriStartEnum(hAsagiri, GetID(), nType);
#else
	HANDLE hEnum = pAsagiri->StartEnum(GetID(), nType);
#endif
	if (hEnum != NULL) {
		nRet = 0;	// nRet == -1 ̏ꍇG[
		CAsaItem* pItem;
		LPTSTR lpszTitle;
		short nID, nItemType;
		nItemType = 0;
		lpszTitle = NULL;
#ifndef _EXPLICIT_LOAD_
		nID = ::AsagiriEnumNext(hAsagiri, hEnum, &lpszTitle, &nItemType, NULL);
#else
		nID = pAsagiri->EnumNext(hEnum, &lpszTitle, &nItemType);
#endif
		while (nID > -1) {
			if (nItemType == ASATYPE_POPUP) {
				pItem = new CPopupItem;
			}
			else {
				pItem = new CValueItem(nItemType);
			}
			if (pItem == NULL) {	// G[
				nRet = -1;	// nRet == -1 ̏ꍇG[
				break;
			}
			pItem->SetTitle(lpszTitle);
			pItem->SetID(nID);
			if (nItemType == ASATYPE_POPUP) {	// |bvAbv̏ꍇ͎qƂɍs
#ifndef _EXPLICIT_LOAD_
				if (((CPopupItem*) pItem)->Populate(hAsagiri, nType, pMap) < 0) {
#else
				if (((CPopupItem*) pItem)->Populate(pAsagiri, nType, pMap) < 0) {
#endif
					delete pItem;
					nRet = -1;	// nRet == -1 ̏ꍇG[
					break;
				}
			}
			else {
				pMap->SetAt((WORD) pItem->GetID(), pItem);
			}
			m_arItems.Add(pItem);
#ifndef _EXPLICIT_LOAD_
			::AsagiriDeleteString(hAsagiri, lpszTitle);	// DLLE܂ō쐬ꂽȂ̂...
#else
			pAsagiri->DeleteString(lpszTitle);	// DLLE܂ō쐬ꂽȂ̂...
#endif
			nItemType = 0;
			lpszTitle = NULL;
#ifndef _EXPLICIT_LOAD_
			nID = ::AsagiriEnumNext(hAsagiri, hEnum, &lpszTitle, &nItemType, NULL);
#else
			nID = pAsagiri->EnumNext(hEnum, &lpszTitle, &nItemType);
#endif
		}
#ifndef _EXPLICIT_LOAD_
		::AsagiriEndEnum(hAsagiri, hEnum);
#else
		pAsagiri->EndEnum(hEnum);
#endif
		if (nRet > -1) {	// nRet == -1 ̏ꍇG[
			nRet = m_arItems.GetSize();
		}
	}

	return nRet;
}

// j[쐬pz֐
CMenu* CPopupItem::CreateMenu()
{
	m_menu.DestroyMenu();
	if (m_menu.CreatePopupMenu() == FALSE) {
		return NULL;
	}

	// `ChACeǉ[v
	CAsaItem* pItem;
	CMenu* pPopup;
	MENUITEMINFO mii;
	for (int i = 0; i < m_arItems.GetSize(); i++) {
		pItem = (CAsaItem*) m_arItems.GetAt(i);
		if (pItem->GetType() == ASATYPE_POPUP) {
			pPopup = pItem->CreateMenu();
			// j[nh
			::ZeroMemory(&mii, sizeof(MENUITEMINFO));
			mii.cbSize = sizeof(MENUITEMINFO);
			mii.fMask = MIIM_SUBMENU | MIIM_STRING;
			mii.hSubMenu = pPopup->GetSafeHmenu();
			// j[
			mii.dwTypeData = (LPTSTR) pItem->GetTitle();
			// j[}
			m_menu.InsertMenuItem((UINT) i, &mii, TRUE);
		}
		else {
			m_menu.AppendMenu(MF_ENABLED | MF_STRING, (UINT_PTR) pItem->GetID() + ASAITEMID_MIN, pItem->GetTitle());
		}
	}
	return &m_menu;
}
